:userdoc.
:docprof toc=123456.
:title.Harbour Reference Guide
.* HBDOC generated IPF Source File.
.* HBDOC Document Source Extractor, (c)1999-2000 Luiz Rafael Culik.
:h1 DOCUY.DOCUMENT
:h2  res=1.ADS Overview
:i1 id=DOCUMX.DOCUMENT
:i2 refid=DOCUMX.ADS OVERVIEW
:p.ADS Overview
.br
.br
:hp2.Advantage Database Server RDD:ehp2.
.br
:p.
:lm margin=6.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.RDDADS is an RDD for the Advantage Database Server&comma. an xBase data  server by Extended Systems <www.advantagedatabase.com>.  The RDD was written by Alexander Kresin <alex@belacy.belgorod.su>  Additional code and
documentation was added by  Brian Hays <bhays@abacuslaw.com>.
.br
:p.Your Harbour application can access a remote database server for a  true client&slash.server architecture&comma. or it can use the &cdq.local server&cdq.  ADSLOC32.DLL for stand&minus.alone or even small network installations.
.br
:p.:hp2.For using this RDD you need to have:   :ehp2.
:p.:hp2.ACE32.DLL    &lpar. Advantage Client Engine &rpar.&comma.   :ehp2.
:p.:hp2.AXCWS32.DLL  &lpar. communication layer for remote server &rpar. or   :ehp2.
:p.:hp2.ADSLOC32.DLL &lpar. local server &rpar.   :ehp2.
.br
:p.You need also to create ace32.lib with the help of implib.exe&colon.  implib ace32.lib ace32.dll
.br
:p.Then build rddads.lib using make&us.b32.bat or make&us.vc.bat.
.br
:p.For building executables don't forget to include the ace32.lib and  rddads.lib in the make file or link script.
.br
:p.You also need to include in your PRG file following lines&colon.
.br
:p.REQUEST &us.ADS
:p.rddRegister&lpar. &cdq.ADS&cdq.&comma. 1 &rpar.
:p.rddsetdefault&lpar. &cdq.ADS&cdq. &rpar.
.br
:p.By default RDDADS is tuned for remote server and cdx indexes. To  change this you may use these commands defined in ads.ch&colon.
.br
:p.SET SERVER LOCAL  SET SERVER REMOTE
.br
:p.SET FILETYPE TO NTX  SET FILETYPE TO ADT  SET FILETYPE TO CDX
.br
:p.or functions AdsSetServerType&lpar.&rpar.&comma. AdsSetFileType&lpar.&rpar..  See the header file ADS.CH for details.
.br
:p.Note that the default local server &lpar.ADSLOC32.DLL&rpar. is useable for  file sharing on a small network.  The default DLL is limited to  5 users&comma. but an unlimited version is available from Extended Systems.
.br
:p.MAX OPEN TABLES&colon. The server &lpar.even local&rpar. has its own setting for  Max Tables allowed open.  For the Local Server&comma. it can be set in  ADSLOCAL.CFG.  The default is only 50!  For the Windows Remote
Servers&comma. use the Configuration Utility&comma. or  increase the setting for the TABLES configuration value in the Advantage  Database Server configuration registry key using the Registry Editor.  For NetWare&comma. edit the
configuration file ADS.CFG.
.br
:p.See ACE.HLP under ADSLOCAL.CFG&comma. or the Advantage Error Guide for  error 7005.
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Every attempt has been made to make the rdd compliant with the  standard dbfcdx rdd at the .PRG level.  One important difference is the handling of structural indexes.  ACE will :hp2.always:ehp2. automatically open an index with
the same  name as the data file.  There is no way to turn this feature off.
.br
:p.Be sure to use the command SET DEFAULT TO &lpar.cDir&rpar. and not its  equivalent Set&lpar.&rpar. function call. The Set&lpar.&rpar. function will not make  the call to ADS to change its internal setting&comma. but the command
will. The same is true for DATEFORMAT&comma. DELETE&comma. and EPOCH.
.br
:p.For programmers who are already familiar with the  ACE engine&comma. this also means there are some differences  between the RDDADS in Harbour and the parallel ACE documentation.
.br
:p.1&rpar. In ACE&comma. skipping backwards to BOF goes to the phantom record and  sets the record number to 0.  In RDDADS&comma. the  record pointer stays at  the Top record and only the BOF flag is set to True.
.br
:p.2&rpar. In RDDADS&comma. a filter expression can be used that may not be  valid on the server &lpar.because of references to public variables or  User&minus.Defined Functions&rpar..  In these cases&comma. all data will come back
from the server  but will be filtered by the application running on the client.  These situations lose the benefits of having a data server and should  be avoided&comma. but they will function as they wou
ld in a Clipper program.
.br
:p.One problem with this scenario is that index key counting  functions that are supposed to give an accurate count respecting  the filter &lpar.e.g. dbOrderInfo&lpar.DBOI&us.KEYCOUNT&rpar. will return the values the  Server knows
about&comma. so the counts will be inaccurate.
.br
:p.3&rpar. When setting a relation&comma. the expression must be one that can be  evaluated by the Advantage Expression Engine.  UDFs will fail.
.br
.br
:h1 ADVAY.ADVANTAGE DATABASE RDD
:h2  res=2.ADSBlob2File()
:i1 id=ADVANX.ADVANTAGE DATABASE RDD
:i2 refid=ADVANX.ADSBLOB2FILE()
:p.ADSBlob2File&lpar.&rpar.
.br
.br
:hp2.Write a Binary &lpar.memo&rpar. field's contents to a file:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSBlob2File&lpar.cFileName&comma. cFieldName&rpar. &minus.&minus.> lSuccess:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFileName>    File to create. If it already exists&comma. it will be  overwritten on success and destroyed on error.
.br
:p.<cFieldName>   Field in the current workarea that contains binary data.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<lSuccess>  True if the file is successfully written.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.  ADSBlob2File&lpar.&rpar. is a wrapper for AdsBinaryToFile.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit only
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=3.ADSFILE2BLOB():elink.
.br
:h2 id=ADVAY res=3.ADSFile2Blob()
:i2 refid=ADVANX.ADSFILE2BLOB()
:p.ADSFile2Blob&lpar.&rpar.
.br
.br
:hp2.Save a Binary file to a field:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSFile2Blob&lpar.cFileName&comma. cFieldName&comma. <nBinaryType>&rpar. &minus.&minus.> lSuccess:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFileName>    File to read. Can be in UNC format. A common example is an image file.
.br
:p.<cFieldName>   Field in the current workarea to contain the binary data.
.br
:p.<nBinaryType>  Either ADS&us.BINARY &lpar.the default&rpar. or ADS&us.IMAGE.  This parameter is for fields in DBF files.  ADT tables cannot store binary and image data in standard character  memo fields &lpar.they have specific
field types for that&rpar..
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<lSuccess>   True if the file is successfully written.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.  ADSFile2Blob&lpar.&rpar. is a wrapper for AdsFileToBinary.  Use of this function is illegal in an ADS transaction.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit only
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=2.ADSBLOB2FILE():elink.
.br
:h2 id=ADVAY res=4.ADSClearAOF()
:i2 refid=ADVANX.ADSCLEARAOF()
:p.ADSClearAOF&lpar.&rpar.
.br
.br
:hp2.Clears an Advantage Optimized Filter in the current workarea.:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSClearAOF&lpar.&rpar.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.None
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.NIL
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=5.ADSCUSTOMIZEAOF():elink.
.br
:link reftype=hd res=6.ADSEVALAOF():elink.
.br
:link reftype=hd res=7.ADSGETAOF():elink.
.br
:link reftype=hd res=8.ADSGETAOFOPTLEVEL():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=5.ADSCustomizeAOF()
:i2 refid=ADVANX.ADSCUSTOMIZEAOF()
:p.ADSCustomizeAOF&lpar.&rpar.
.br
.br
:hp2.Add or remove records from an existing AOF:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSCustomizeAOF&lpar. &lbrk.<nRecno &splitvbar. aRecNos>&rbrk.. &lbrk.&comma. <nType>&rbrk.. &rpar. &minus.&minus.> nSuccess:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nRecno &splitvbar. aRecNos> Can be either a single record number or an array of  record numbers to add or delete from the AOF. If omitted&comma. defaults to  the current record.
.br
:p.<nType>   The type of operation&colon.
.br
:table cols='21 71'.
:row.
:c.ADS_AOF_ADD_RECORD
:c.Add the record to the AOF (set the bit). This is the default operation.
:row.
:c.ADS_AOF_REMOVE_RECORD
:c.Remove the record from the AOF (clear the bit).
:row.
:c.ADS_AOF_TOGGLE_RECORD
:c.Switch the record into or out of the AOF.
:etable.
.br
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<nError>  ADS error code&comma. or 0 for success.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.An Advantage Optimized Filter &lpar.AOF&rpar. consists of a bitmap of the records in  the database. If bit 5 is on&comma. record 5 is considered a visible record.  If bit 5 is off&comma. record 5 is not visible. It does not
&cdq.pass the test&cdq..  Initially&comma. the bits are set by the Server according to a filter expression  from SET FILTER TO or adsSetAOF&lpar.&rpar.. But by using ADSCustomizeAOF&lpar.&rpar. you can  add or remove records at
will from the visible set.  This is useful for  tagging records or for refining a result set after the data has been retrieved  from the server.
.br
:p.The maximum number of records that can be customized in a single call is  16&comma.383&comma. so <aRecNos> must not be longer than this.
.br
:p.Calls to AdsCustomizeAOF must be made after an application has created a  filter with a call to AdsSetAOF. To create a completely empty record set  &lpar.to which records can be added with calls to AdsCustomizeAOF&rpar.&comma.
use &cdq..F.&cdq. as  the filter expression given to AdsSetAOF. To create a completely full  record set &lpar.from which records can be removed&rpar.&comma. use &cdq..T.&cdq. as the filter  expression.
.br
:p.WARNING&colon. Always start with a FULLY optimized AOF!  If an application must use a filter expression that is not fully optimized  as the starting point for customization&comma. the ADS&us.RESOLVE&us.IMMEDIATE option  should be
used with the call to AdsSetAOF. Otherwise&comma. the dynamic filter  resolution that occurs on the server will automatically remove records that  have been added through the AdsCustomizeAOF calls. The  filter expressions
&cdq..T.&cdq. and &cdq..F.&cdq. both result in fully optimized AOFs  regardless of available indexes.
.br
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=6.ADSEVALAOF():elink.
.br
:link reftype=hd res=7.ADSGETAOF():elink.
.br
:link reftype=hd res=8.ADSGETAOFOPTLEVEL():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=6.ADSEvalAOF()
:i2 refid=ADVANX.ADSEVALAOF()
:p.ADSEvalAOF&lpar.&rpar.
.br
.br
:hp2.Evaluate a filter expression to determine its optimization level:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSEvalAOF&lpar.<cFilter>&rpar. &minus.&minus.> nOptimizationLevel:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFilter>       Expression to test.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<nOptimizationLevel>
.br
:p.Values are defined in ads.ch&colon.  ADS&us.OPTIMIZED&us.FULL&comma. ADS&us.OPTIMIZED&us.PART&comma. ADS&us.OPTIMIZED&us.NONE.  IMPORTANT NOTE&colon. These values are NOT the same as those returned  by dbOrderInfo&lpar.&rpar..
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=7.ADSGETAOF():elink.
.br
:link reftype=hd res=8.ADSGETAOFOPTLEVEL():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=8.ADSGetAOFoptLevel()
:i2 refid=ADVANX.ADSGETAOFOPTLEVEL()
:p.ADSGetAOFoptLevel&lpar.&rpar.
.br
.br
:hp2.Returns optimization level of the current AOF filter:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSGetAOFoptLevel&lpar.&rpar. &minus.&minus.> nOptimizationLevel:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.None
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<nOptimizationLevel>
.br
:p.Values are defined in ads.ch&colon.  ADS&us.OPTIMIZED&us.FULL&comma. ADS&us.OPTIMIZED&us.PART&comma. ADS&us.OPTIMIZED&us.NONE.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=7.ADSGETAOF():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=7.ADSGetAOF()
:i2 refid=ADVANX.ADSGETAOF()
:p.ADSGetAOF&lpar.&rpar.
.br
.br
:hp2.Retrieve the filter expression used in the call to AdsSetAOF:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSGetAOF&lpar.&rpar. &minus.&minus.> cFilter:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.None
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<cFilter>  The filter expression used in the call to AdsSetAOF.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=8.ADSGETAOFOPTLEVEL():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=11.ADSGetAOFnoOpt()
:i2 refid=ADVANX.ADSGETAOFNOOPT()
:p.ADSGetAOFnoOpt&lpar.&rpar.
.br
.br
:hp2.Return the non&minus.optimized portion of the current filter expression:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSGetAOFnoOpt&lpar.&rpar. &minus.&minus.> cFilterFragment:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.None
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<cFilterFragment>  If an AOF filter expression is not fully optimizable&comma.  the non&minus.optimizable part of the expression can be retrieved with this function.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=10.ADSRefreshAOF()
:i2 refid=ADVANX.ADSREFRESHAOF()
:p.ADSRefreshAOF&lpar.&rpar.
.br
.br
:hp2.Update the filter snapshot:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSRefreshAOF&lpar.&rpar.:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.None
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.NIL
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.  If record updates occur after an AOF is set&comma. the updated records may  or may not be valid records for the filter. ADSRefreshAOF&lpar.&rpar.
re&minus.evaluates the data to include or exclude changed records.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=12.ADSSETAOF():elink.
.br
:h2 id=ADVAY res=12.ADSSetAOF()
:i2 refid=ADVANX.ADSSETAOF()
:p.ADSSetAOF&lpar.&rpar.
.br
.br
:hp2.Create an Advantage Optimized Filter:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSSetAOF&lpar. <cFilter> &lbrk.&comma. <nResolveOption>&rbrk.. &rpar. &minus.&minus.> lSuccess:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<cFilter>         Filter expression to set.
.br
:p.<nResolveOption>  Option to indicate how the filter should be resolved  in the event that the expression cannot be fully optimized.  Options are defined in ads.ch&colon.  ADS&us.RESOLVE&us.IMMEDIATE&comma.
ADS&us.RESOLVE&us.DYNAMIC.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<lSuccess>   True if AOF is created.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=9.ADSISRECORDINAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=9.ADSIsRecordInAOF()
:i2 refid=ADVANX.ADSISRECORDINAOF()
:p.ADSIsRecordInAOF&lpar.&rpar.
.br
.br
:hp2.Determine if a record is in the current AOF:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSIsRecordInAOF&lpar. &lbrk.<nRecNo>&rbrk.. &rpar. &minus.&minus.> lSatisfiesFilter:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<nRecNo>         Record number to test. Default is current record.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.True if the record satisfies the filter criteria.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=4.ADSCLEARAOF():elink.
.br
:link reftype=hd res=10.ADSREFRESHAOF():elink.
.br
:h2 id=ADVAY res=13.ADSGetRelKeyPos()
:i2 refid=ADVANX.ADSGETRELKEYPOS()
:p.ADSGetRelKeyPos&lpar.&rpar.
.br
.br
:hp2.Estimated key position of current record within the specified index:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSGetRelKeyPos&lpar.&lbrk.<xTag>&rbrk..&rpar. &minus.&minus.> nKeyPos:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<xTag>  Index to use. Default is current index.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.The relative key position within the current index.  This function estimates the position of the current key in the indicated  index order. The value returned is between 0.0 and 1.0&comma. inclusive.  If there are scopes set on
the index order&comma. the position returned  is relative to the visible records.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=14.ADSKEYNO():elink.
.br
:link reftype=hd res=15.ADSKEYCOUNT():elink.
.br
:h2 id=ADVAY res=15.ADSKeyCount()
:i2 refid=ADVANX.ADSKEYCOUNT()
:p.ADSKeyCount&lpar.&rpar.
.br
.br
:hp2.Retrieve the number of keys in a specified index:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSKeyCount&lpar.&lbrk.<xTag>&rbrk..&comma. <cIgnoredIndexFile>&comma. &lbrk.<nFilterOption>&rbrk..&rpar. &minus.&minus.> nKeyCount:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<xTag>     Numeric order number OR index tag name. Default is current index.
.br
:p.<cIgnoredIndexFile>   This parameter is not processed. In other Harbour RDDs&comma.  the second parameter to &cdq.ordKeyCount&cdq. takes a second argument to identify  a particular Index File in cases where two files are open
that contain  orders with the same name. The ADS driver does not support this and  will select the first order with the requested name. To stay consistent  with other RDDs&comma. therefore&lpar.&rpar.&comma.the second parameter
is reserved and the  <nFilterOption> is passed as a third parameter.
.br
:p.<nFilterOption> Indicates if filters and&slash.or scopes are to be respected if set.
.br
:p.Options are defined in ads.ch&colon.
.br
:table cols='18 26'.
:row.
:c.ADS_RESPECTFILTERS
:c.Respect filters and scopes
:row.
:c.ADS_IGNOREFILTERS
:c.Ignore filters and scopes
:row.
:c.ADS_RESPECTSCOPES
:c.Respect scopes only
:etable.
.br
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<nKeyCount>  The number of keys within the current index.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=14.ADSKEYNO():elink.
.br
:link reftype=hd res=13.ADSGETRELKEYPOS():elink.
.br
:h2 id=ADVAY res=14.ADSKeyNo()
:i2 refid=ADVANX.ADSKEYNO()
:p.ADSKeyNo&lpar.&rpar.
.br
.br
:hp2.Get the logical key number of the current record in the given index:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSKeyNo&lpar.&lbrk.<xTag>&rbrk..&comma. &lbrk.<nFilterOption>&rbrk..&rpar. &minus.&minus.> nKeyNo:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<xTag>          Numeric order number OR index tag name. Default is current index.
.br
:p.<nFilterOption> Indicates if filters and&slash.or scopes are to be respected if set.
.br
:row.
:c.
:row.
:c.
:row.
:c.
:row.
:c.
:etable.
.br
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<nKeyNo>   The logical key number of the current record in the given index.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.
:p.Wrapper for AdsGetKeyNum.
:p.This function may be slow on a large database with  ADS&us.RESPECTFILTERS set because it walks through the keys to get the  current position.  Compare to ADSGetRelKeyPos&lpar.&rpar..
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=15.ADSKEYCOUNT():elink.
.br
:link reftype=hd res=13.ADSGETRELKEYPOS():elink.
.br
:h2 id=ADVAY res=16.ADSLocking()
:i2 refid=ADVANX.ADSLOCKING()
:p.ADSLocking&lpar.&rpar.
.br
.br
:hp2.Turns on&slash.off the Advantage proprietary locking mode:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSLocking&lpar. <lMode> &rpar. &minus.&minus.> lPriorSetting:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<lMode>    .T. to use the Advantage proprietary locking mode  &lpar.this is the default setting if a remote server is used&rpar.  or pass .F. to use &cdq.compatibility&cdq. locking.
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<lPriorSetting>   .T. if prior setting was for the proprietary mode.
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.  The Advantage Database Server has a fast Proprietary locking mode that  is more efficient than traditional network locking. It is only available  when using the
remote server &lpar.not the local server&rpar..
.br
:p.If a file is opened in the proprietary mode&comma. other applications cannot  open it in a &cdq.write&cdq. mode. So if non&minus.Advantage applications need  concurrent access to the data files&comma. use the Compatibility
locking mode  by calling  ADSLocking&lpar. .F. &rpar..
.br
:p.ADSLocking&lpar.&rpar. is a Get&slash.Set function for the locking mode. It affects  files at the time they are opened. So when a data  file is opened&comma. the current setting is used for that file until it is  closed.
Different files can have different locking modes by changing  the setting before opening a second file.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=17.ADSRIGHTSCHECK():elink.
.br
:h2 id=ADVAY res=17.ADSRightsCheck()
:i2 refid=ADVANX.ADSRIGHTSCHECK()
:p.ADSRightsCheck&lpar.&rpar.
.br
.br
:hp2.Sets the &cdq.rights checking&cdq. setting for opening files:ehp2.
.br
:p.
:lm margin=6.
.br
:hp2.Syntax:ehp2.
.br
:p.
:lm margin=6.
:p.:hp2.ADSRightsCheck&lpar. <lMode> &rpar. &minus.&minus.> lPriorSetting:ehp2.
.br
.br
:hp2.Arguments:ehp2.
.br
:p.
:lm margin=6.
:p.<lMode>    .T. to check rights upon opening data files &lpar.the default&rpar.&comma.  or .F. to ignore rights
.br
.br
:hp2.Returns:ehp2.
.br
:p.
:lm margin=6.
:p.<lPriorSetting>
.br
.br
:hp2.Description:ehp2.
.br
:p.
:lm margin=6.
:p.See ACE.HLP for full details about the Advantage Database Server.  ADSRightsCheck&lpar.&rpar. is a Get&slash.Set function for the &cdq.rights checking&cdq. mode.  If the setting is .T. when a file is opened&comma. then the
Advantage  Database Server will use the rights of the connected user when  opening the file. If the user does not have rights to the  directory or server&comma. then the open call will fail.
.br
:p.If the setting is .F.&comma. then the ADS will  ignore the connected user's rights and open the file  regardless. This lets you allow only  Advantage&minus.based applications to access specific data.
.br
:hp2.Status:ehp2.
.br
:p.
:lm margin=6.
Ready
.br
.br
:hp2.Compliance:ehp2.
.br
:p.
:lm margin=6.
:p.Harbour extension
.br
.br
:hp2.Platforms:ehp2.
.br
:p.
:lm margin=6.
:p.Windows 32&minus.bit
.br
.br
:hp2.Files:ehp2.
.br
:p.
:lm margin=6.
:p.Library is RddAds  Header is ads.ch
.br
.br
:hp2.See Also&colon.:ehp2.
.br
:p.
:lm margin=6.
:link reftype=hd res=16.ADSLOCKING():elink.
.br
:euserdoc.
